Package com.google.android.exoplayer2.extractor

## Interface Extractor

- All Known Implementing Classes:
    `Ac3Extractor`, `Ac4Extractor`, `AdtsExtractor`, `AmrExtractor`, `AviExtractor`, `FlacExtractor`, `FlacExtractor`, `FlvExtractor`, `FragmentedMp4Extractor`, `JpegExtractor`, `MatroskaExtractor`, `Mp3Extractor`, `Mp4Extractor`, `OggExtractor`, `PsExtractor`, `SubtitleExtractor`, `TsExtractor`, `WavExtractor`, `WebvttExtractor`

      public interface Extractor

  Extracts media data from a container format.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface | Description
    --- | --- | ---
    `static interface` | `Extractor.ReadResult` | Result values that can be returned by `read(ExtractorInput, PositionHolder)`.

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static int` | `RESULT_CONTINUE` | Returned by `read(ExtractorInput, PositionHolder)` if the `ExtractorInput` passed to the next `read(ExtractorInput, PositionHolder)` is required to provide data continuing from the position in the stream reached by the returning call.
    `static int` | `RESULT_END_OF_INPUT` | Returned by `read(ExtractorInput, PositionHolder)` if the end of the `ExtractorInput` was reached.
    `static int` | `RESULT_SEEK` | Returned by `read(ExtractorInput, PositionHolder)` if the `ExtractorInput` passed to the next `read(ExtractorInput, PositionHolder)` is required to provide data starting from a specified position in the stream.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `init​(ExtractorOutput output)` | Initializes the extractor with an `ExtractorOutput`.
    `@com.google.android.exoplayer2.extractor.Extractor.ReadResult int` | `read​(ExtractorInput input, PositionHolder seekPosition)` | Extracts data read from a provided `ExtractorInput`.
    `void` | `release()` | Releases all kept resources.
    `void` | `seek​(long position, long timeUs)` | Notifies the extractor that a seek has occurred.
    `boolean` | `sniff​(ExtractorInput input)` | Returns whether this extractor can extract samples from the `ExtractorInput`, which must provide data from the start of the stream.

- - ### Field Detail

    - #### RESULT_CONTINUE

          static final int RESULT_CONTINUE

      Returned by `read(ExtractorInput, PositionHolder)` if the `ExtractorInput` passed to the next `read(ExtractorInput, PositionHolder)` is required to provide data continuing from the position in the stream reached by the returning call.
      See Also:
        Constant Field Values

    - #### RESULT_SEEK

          static final int RESULT_SEEK

      Returned by `read(ExtractorInput, PositionHolder)` if the `ExtractorInput` passed to the next `read(ExtractorInput, PositionHolder)` is required to provide data starting from a specified position in the stream.
      See Also:
        Constant Field Values

    - #### RESULT_END_OF_INPUT

          static final int RESULT_END_OF_INPUT

      Returned by `read(ExtractorInput, PositionHolder)` if the end of the `ExtractorInput` was reached. Equal to `C.RESULT_END_OF_INPUT`.
      See Also:
        Constant Field Values

  - ### Method Detail

    - #### sniff

          boolean sniff​(ExtractorInput input)
                 throws IOException

      Returns whether this extractor can extract samples from the `ExtractorInput`, which must provide data from the start of the stream.

      If `true` is returned, the `input`'s reading position may have been modified. Otherwise, only its peek position may have been modified.

      Parameters:
        `input` - The `ExtractorInput` from which data should be peeked/read.
      Returns:
        Whether this extractor can read the provided input.
      Throws:
        `IOException` - If an error occurred reading from the input.

    - #### init

          void init​(ExtractorOutput output)

      Initializes the extractor with an `ExtractorOutput`. Called at most once.
      Parameters:
        `output` - An `ExtractorOutput` to receive extracted data.

    - #### read

          @com.google.android.exoplayer2.extractor.Extractor.ReadResult int read​(ExtractorInput input,
                                                                                 PositionHolder seekPosition)
                                                                          throws IOException

      Extracts data read from a provided `ExtractorInput`. Must not be called before `init(ExtractorOutput)`.

      A single call to this method will block until some progress has been made, but will not block for longer than this. Hence each call will consume only a small amount of input data.

      In the common case, `RESULT_CONTINUE` is returned to indicate that the `ExtractorInput` passed to the next read is required to provide data continuing from the position in the stream reached by the returning call. If the extractor requires data to be provided from a different position, then that position is set in `seekPosition` and `RESULT_SEEK` is returned. If the extractor reached the end of the data provided by the `ExtractorInput`, then `RESULT_END_OF_INPUT` is returned.

      When this method throws an `IOException`, extraction may continue by providing an `ExtractorInput` with an unchanged `read position` to a subsequent call to this method.

      Parameters:
        `input` - The `ExtractorInput` from which data should be read.
        `seekPosition` - If `RESULT_SEEK` is returned, this holder is updated to hold the position of the required data.
      Returns:
        One of the `RESULT_` values defined in this interface.
      Throws:
        `IOException` - If an error occurred reading from or parsing the input.

    - #### seek

          void seek​(long position,
                    long timeUs)

      Notifies the extractor that a seek has occurred.

      Following a call to this method, the `ExtractorInput` passed to the next invocation of `read(ExtractorInput, PositionHolder)` is required to provide data starting from `position` in the stream. Valid random access positions are the start of the stream and positions that can be obtained from any `SeekMap` passed to the `ExtractorOutput`.

      Parameters:
        `position` - The byte offset in the stream from which data will be provided.
        `timeUs` - The seek time in microseconds.

    - #### release

          void release()

      Releases all kept resources.